export var ShowCases;
(function (ShowCases) {
    /** No listener - show on init + only manual call `.$hide()` & `.$show()` */
    ShowCases[ShowCases["always"] = 0] = "always";
    /** On `mouseenter` event of target; hide by `mouseleave` */
    ShowCases[ShowCases["onHover"] = 1] = "onHover";
    /** On `focusIn` event of target; hide by `focusout` (also on click if PopupShowCases.onClick included) */
    ShowCases[ShowCases["onFocus"] = 2] = "onFocus";
    /** On `click` event of target; hide by click anywhere */
    ShowCases[ShowCases["onClick"] = 4] = "onClick";
    /** No listener - only manual call `.$hide()` & `.$show()` */
    ShowCases[ShowCases["alwaysOff"] = 8] = "alwaysOff";
})(ShowCases || (ShowCases = {}));
export var HideCases;
(function (HideCases) {
    /** When $hide() is called programmatically */
    HideCases[HideCases["onManuallCall"] = 0] = "onManuallCall";
    /** When mouse left target & popup */
    HideCases[HideCases["onMouseLeave"] = 1] = "onMouseLeave";
    /** When focus left target & popup */
    HideCases[HideCases["onFocusOut"] = 2] = "onFocusOut";
    /** When was click outside target & popup */
    HideCases[HideCases["onOutsideClick"] = 3] = "onOutsideClick";
    /** When was click on popup */
    HideCases[HideCases["onPopupClick"] = 4] = "onPopupClick";
    /** When was click on target & popup was opened */
    HideCases[HideCases["onTargetClick"] = 5] = "onTargetClick";
    /** When target removed from document */
    HideCases[HideCases["onTargetRemove"] = 6] = "onTargetRemove";
    /** When options or attributes changes */
    HideCases[HideCases["onOptionChange"] = 7] = "onOptionChange";
    /** When user pressed Escape button */
    HideCases[HideCases["onPressEsc"] = 8] = "onPressEsc";
})(HideCases || (HideCases = {}));
export var Animations;
(function (Animations) {
    /** Via opacity/css-style */
    Animations[Animations["default"] = 0] = "default";
    /** Dropdown/drawer animation. It's implemented via JS */
    Animations[Animations["drawer"] = 1] = "drawer";
    /** Animate (show/hide) element as dropdown via moving every item to position step by step
     * @tutorial expected structure
     * * use attr [items] `<div items><button>item 1</button>...</div>`
     * * use <li/> `<ul><li><button>item 1</button></li>...</ul>`
     * * use nested structure <div><button>item 1</button>...</div>
     * * or use without wrapper <button>item 1</button>... */
    Animations[Animations["stack"] = 2] = "stack";
})(Animations || (Animations = {}));
// export {}; // https://www.typescriptlang.org/docs/handbook/declaration-files/templates/global-modifying-module-d-ts.html
